#!/usr/bin/python

# Generates region file for the 4-way junction with 2 bases between

import sys, os, string, math, random

if len(sys.argv)<2:
  print "Not enough input arguments"
  print "genregionfile.py Nlevels"
  sys.exit()
else:
  Nlevels = int(sys.argv[1]);

pts = '1.e-4'
prs = '1.e-5'
ptsf = '1.e-7'
prsf = '1.e-8'
ptsr = '1.e-7'
prsr = '1.e-8'
ptsri = '0.0'
prsri = '0.0'

### first define individual regions
strand = ['A','B','C','D'];
strandm = ['D','A','B','C'];

levels = []; bplevels = []
for i in range(0,len(strand)):
  currlevel = []; currbp = [];
  for ai in range(1,9):
    currmem = '%s:%d' %(strand[i],ai);
    currlevel.append(currmem);
  for aj in range(19,11,-1):
    currmem = '%s:%d' %(strandm[i],aj);
    currlevel.append(currmem);
 
  ## now to store currbp
  for ai in range(1,9):
    currmem = '%s,%s' %(currlevel[ai-1],currlevel[ai+8-1])
    currbp.append(currmem)
  levels.append(currlevel);
  bplevels.append(currbp);

### now store the ssregions
ssall = []
for i in range(0,len(strand)):
  currss = [];
  for ai in range(9,12):
    currmem = '%s:%d' %(strand[i],ai);
    currss.append(currmem);
  ssall.append(currss)
    
### only helices levels
for i in range(0,4):
  print '~region[\element_top_type{residue}'
  print '        \dependency_type{independent}'
  print '        \\nres{%d}' %(len(levels[i]))
  print '        \\residues{',
  for ai in range(0,len(levels[i])-1):
    me = '%s,' %(levels[i][ai].strip())
    sys.stdout.write(me)
  sys.stdout.write(levels[i][len(levels[i])-1])
  print '}'
  print '        \\ncenter{2}' 
  print '        \\centers{',
  me = '%s,' %(levels[i][7].strip())
  sys.stdout.write(me)
  sys.stdout.write(levels[i][len(levels[i])-1])
  print '}'
#  print '        \\ncenter{%d}' %(len(levels[i]))
#  print '        \\centers{',
#  for ai in range(0,len(levels[i])-1):
#    me = '%s,' %(levels[i][ai].strip())
#    sys.stdout.write(me)
#  sys.stdout.write(levels[i][len(levels[i])-1])
#  print '}'
  #print '        \center{%s}' %(levels[i][7])
  print '        \\nrespair{%d}' %(len(bplevels[i])) 
  for ai in range(0,len(bplevels[i])):
    print '        \\residue_pair{%s}' %(bplevels[i][ai])
  print '        \prop_trans_sig{%s}' %(pts)
  print '        \prop_rot_sig{%s}' %(prs)
  print '        \prop_trans_sig_freeres{%s}' %(ptsf)
  print '        \prop_rot_sig_freeres{%s}' %(prsf)
  print '        \prop_trans_sig_respair{%s}' %(ptsr)
  print '        \prop_rot_sig_respair{%s}' %(prsr)
  print '        \prop_trans_sig_respair_internal{%s}' %(ptsri)
  print '        \prop_rot_sig_respair_internal{%s}' %(prsri)
  print ']'

### now the ss levels
for i in range(0,4):
  print '~region[\element_top_type{residue}'
  print '        \dependency_type{independent}'
  print '        \\nres{%d}' %(len(ssall[i]))
  print '        \\residues{',
  for ai in range(0,len(ssall[i])-1):
    me = '%s,' %(ssall[i][ai].strip())
    sys.stdout.write(me)
  sys.stdout.write(ssall[i][len(ssall[i])-1])
  print '}'
#  print '        \\ncenter{%d}' %(len(ssall[i]))
#  print '        \\centers{',
#  for ai in range(0,len(ssall[i])-1):
#    me = '%s,' %(ssall[i][ai].strip())
#    sys.stdout.write(me)
#  sys.stdout.write(ssall[i][len(ssall[i])-1])
#  print '}'
  print '        \\ncenter{1}' 
  print '        \centers{%s}' %(ssall[i][1])
#  print '        \center{%s}' %(ssall[i][1])
  print '        \\nrespair{0}' 
  print '        \prop_trans_sig{%s}' %(pts)
  print '        \prop_rot_sig{%s}' %(prs)
  print '        \prop_trans_sig_freeres{%s}' %(ptsf)
  print '        \prop_rot_sig_freeres{%s}' %(prsf)
  print '        \prop_trans_sig_respair{%s}' %(ptsr)
  print '        \prop_rot_sig_respair{%s}' %(prsr)
  print '        \prop_trans_sig_respair_internal{%s}' %(ptsri)
  print '        \prop_rot_sig_respair_internal{%s}' %(prsri)
  print ']'

if (Nlevels ==2 or Nlevels == 3):
  ## need to include 0-1, 1-2, 2-3, 3-0
  for i in range(0,4):
    currlevel = []; currbp = [];
    if (i !=3):
      for sa in range(0,len(levels[i])):
        currlevel.append(levels[i][sa]);
      for sa in range(0,len(levels[i+1])):
        currlevel.append(levels[i+1][sa]);  
      for sa in range(0,len(ssall[i])):
        currlevel.append(ssall[i][sa]);   
      for sa in range(0,len(bplevels[i])):
        currbp.append(bplevels[i][sa]);
      for sa in range(0,len(bplevels[i+1])):
        currbp.append(bplevels[i+1][sa]);
    else:
      for sa in range(0,len(levels[i])):
        currlevel.append(levels[i][sa]);
      for sa in range(0,len(levels[0])):
        currlevel.append(levels[0][sa]); 
      for sa in range(0,len(ssall[i])):
        currlevel.append(ssall[i][sa]);  
      for sa in range(0,len(bplevels[i])):
        currbp.append(bplevels[i][sa]);
      for sa in range(0,len(bplevels[0])):
        currbp.append(bplevels[0][sa]);  
    print '~region[\element_top_type{residue}'
    print '        \dependency_type{independent}'
    print '        \\nres{%d}' %(len(currlevel))
    print '        \\residues{',
    for ai in range(0,len(currlevel)-1):
      me = '%s,' %(currlevel[ai].strip())
      sys.stdout.write(me)
    sys.stdout.write(currlevel[len(currlevel)-1])
    print '}'
#    print '        \\ncenter{%d}' %(len(currlevel))
#    print '        \\centers{',
#    for ai in range(0,len(currlevel)-1):
#      me = '%s,' %(currlevel[ai].strip())
#      sys.stdout.write(me)
#    sys.stdout.write(currlevel[len(currlevel)-1])
#    print '}'
    print '        \\ncenter{1}'
    print '        \centers{%s}' %(currlevel[len(currlevel)-2])
#    print '        \center{%s}' %(currlevel[len(currlevel)-2])
    print '        \\nrespair{%d}' %(len(currbp)) 
    for ai in range(0,len(currbp)):
      print '        \\residue_pair{%s}' %(currbp[ai])
    print '        \prop_trans_sig{%s}' %(pts)
    print '        \prop_rot_sig{%s}' %(prs)
    print '        \prop_trans_sig_freeres{%s}' %(ptsf)
    print '        \prop_rot_sig_freeres{%s}' %(prsf)
    print '        \prop_trans_sig_respair{%s}' %(ptsr)
    print '        \prop_rot_sig_respair{%s}' %(prsr)
    print '        \prop_trans_sig_respair_internal{%s}' %(ptsri)
    print '        \prop_rot_sig_respair_internal{%s}' %(prsri)
    print ']'

  # also include helices across each other
  for i in range(0,2):
    currlevel = []; currbp = [];
    for sa in range(0,len(levels[i])):
      currlevel.append(levels[i][sa]);
    for sa in range(0,len(levels[i+2])):
      currlevel.append(levels[i+2][sa]);  
    for sa in range(0,len(bplevels[i])):
      currbp.append(bplevels[i][sa]);
    for sa in range(0,len(bplevels[i+2])):
      currbp.append(bplevels[i+2][sa]);
    print '~region[\element_top_type{residue}'
    print '        \dependency_type{independent}'
    print '        \\nres{%d}' %(len(currlevel))
    print '        \\residues{',
    for ai in range(0,len(currlevel)-1):
      me = '%s,' %(currlevel[ai].strip())
      sys.stdout.write(me)
    sys.stdout.write(currlevel[len(currlevel)-1])
    print '}'
    print '        \\ncenter{4}' 
    print '        \\centers{',
    me = '%s,' %(currlevel[7].strip())
    sys.stdout.write(me)
    me = '%s,' %(currlevel[15].strip())
    sys.stdout.write(me)
    me = '%s,' %(currlevel[23].strip())
    sys.stdout.write(me)
    sys.stdout.write(currlevel[31])
    print '}'
#    print '        \\ncenter{%d}' %(len(currlevel))
#    print '        \\centers{',
#    for ai in range(0,len(currlevel)-1):
#      me = '%s,' %(currlevel[ai].strip())
#      sys.stdout.write(me)
#    sys.stdout.write(currlevel[len(currlevel)-1])
#    print '}'
#    print '        \center{%s}' %(currlevel[len(currlevel)-2])
    print '        \\nrespair{%d}' %(len(currbp)) 
    for ai in range(0,len(currbp)):
      print '        \\residue_pair{%s}' %(currbp[ai])
    print '        \prop_trans_sig{%s}' %(pts)
    print '        \prop_rot_sig{%s}' %(prs)
    print '        \prop_trans_sig_freeres{%s}' %(ptsf)
    print '        \prop_rot_sig_freeres{%s}' %(prsf)
    print '        \prop_trans_sig_respair{%s}' %(ptsr)
    print '        \prop_rot_sig_respair{%s}' %(prsr)
    print '        \prop_trans_sig_respair_internal{%s}' %(ptsri)
    print '        \prop_rot_sig_respair_internal{%s}' %(prsri)
    print ']'
 
if (Nlevels ==3):  
  for i in range(0,4):
    currlevel = []; currbp = [];
    if (i ==0):
      for sa in range(0,len(levels[i])):
        currlevel.append(levels[i][sa]);
      for sa in range(0,len(levels[i+1])):
        currlevel.append(levels[i+1][sa]);
      for sa in range(0,len(levels[i+2])):
        currlevel.append(levels[i+2][sa]);  
      for sa in range(0,len(ssall[i])):
        currlevel.append(ssall[i][sa]);  
      for sa in range(0,len(ssall[i+1])):
        currlevel.append(ssall[i+1][sa]);   
      for sa in range(0,len(bplevels[i])):
        currbp.append(bplevels[i][sa]);
      for sa in range(0,len(bplevels[i+1])):
        currbp.append(bplevels[i+1][sa]);
      for sa in range(0,len(bplevels[i+2])):
        currbp.append(bplevels[i+2][sa]);
    elif (i ==1):
      for sa in range(0,len(levels[i])):
        currlevel.append(levels[i][sa]);
      for sa in range(0,len(levels[i+1])):
        currlevel.append(levels[i+1][sa]);
      for sa in range(0,len(levels[i+2])):
        currlevel.append(levels[i+2][sa]);  
      for sa in range(0,len(ssall[i])):
        currlevel.append(ssall[i][sa]);  
      for sa in range(0,len(ssall[i+1])):
        currlevel.append(ssall[i+1][sa]);   
      for sa in range(0,len(bplevels[i])):
        currbp.append(bplevels[i][sa]);
      for sa in range(0,len(bplevels[i+1])):
        currbp.append(bplevels[i+1][sa]);
      for sa in range(0,len(bplevels[i+2])):
        currbp.append(bplevels[i+2][sa]);
    elif (i==2):
      for sa in range(0,len(levels[i])):
        currlevel.append(levels[i][sa]);
      for sa in range(0,len(levels[i+1])):
        currlevel.append(levels[i+1][sa]);
      for sa in range(0,len(levels[0])):
        currlevel.append(levels[0][sa]);  
      for sa in range(0,len(ssall[i])):
        currlevel.append(ssall[i][sa]);  
      for sa in range(0,len(ssall[i+1])):
        currlevel.append(ssall[i+1][sa]);   
      for sa in range(0,len(bplevels[i])):
        currbp.append(bplevels[i][sa]);
      for sa in range(0,len(bplevels[i+1])):
        currbp.append(bplevels[i+1][sa]);
      for sa in range(0,len(bplevels[0])):
        currbp.append(bplevels[0][sa]);
    else:
      for sa in range(0,len(levels[i])):
        currlevel.append(levels[i][sa]);
      for sa in range(0,len(levels[0])):
        currlevel.append(levels[0][sa]); 
      for sa in range(0,len(levels[1])):
        currlevel.append(levels[1][sa]); 
      for sa in range(0,len(ssall[i])):
        currlevel.append(ssall[i][sa]);  
      for sa in range(0,len(ssall[0])):
        currlevel.append(ssall[0][sa]); 
      for sa in range(0,len(bplevels[i])):
        currbp.append(bplevels[i][sa]);
      for sa in range(0,len(bplevels[0])):
        currbp.append(bplevels[0][sa]);
      for sa in range(0,len(bplevels[1])):
        currbp.append(bplevels[1][sa]);  
    print '~region[\element_top_type{residue}'
    print '        \dependency_type{independent}'
    print '        \\nres{%d}' %(len(currlevel))
    print '        \\residues{',
    for ai in range(0,len(currlevel)-1):
      me = '%s,' %(currlevel[ai].strip())
      sys.stdout.write(me)
    sys.stdout.write(currlevel[len(currlevel)-1])
    print '}'
    print '        \\ncenter{2}' 
    print '        \\centers{',
    me = '%s,' %(currlevel[23].strip())
    sys.stdout.write(me)
    sys.stdout.write(currlevel[31])
    print '}'
#    print '        \\ncenter{%d}' %(len(currlevel))
#    print '        \\centers{',
#    for ai in range(0,len(currlevel)-1):
#      me = '%s,' %(currlevel[ai].strip())
#      sys.stdout.write(me)
#    sys.stdout.write(currlevel[len(currlevel)-1])
#    print '}'
#    print '        \center{%s}' %(currlevel[23])
    print '        \\nrespair{%d}' %(len(currbp)) 
    for ai in range(0,len(currbp)):
      print '        \\residue_pair{%s}' %(currbp[ai])
    print '        \prop_trans_sig{%s}' %(pts)
    print '        \prop_rot_sig{%s}' %(prs)
    print '        \prop_trans_sig_freeres{%s}' %(ptsf)
    print '        \prop_rot_sig_freeres{%s}' %(prsf)
    print '        \prop_trans_sig_respair{%s}' %(ptsr)
    print '        \prop_rot_sig_respair{%s}' %(prsr)
    print '        \prop_trans_sig_respair_internal{%s}' %(ptsri)
    print '        \prop_rot_sig_respair_internal{%s}' %(prsri)
    print ']'
